
-- 4x4 grid

--	1   2   3   4
--  5   6   7   8
--  9   10  11  12
--  13  14  15  16

-- State 16: +1 reward
--    everything else 0


-- program options
debug_mode = false;

-- initialise prng
seed = os.time()
math.randomseed(seed)
math.random(); math.random(); math.random();

encode_rew = {}
encode_rew[0]   = '0'
encode_rew[1]   = '1'

decode_act = {}
decode_act['00'] = 'north'
decode_act['01'] = 'east'
decode_act['10'] = 'south'
decode_act['11'] = 'west'


-- reset the POMDP to the starting state
function assign_robot ()

	robot_state = math.random(15)
	dprint('robot_state=' .. robot_state)

end


-- compute the next observation based on the world state
function compute_observation ()
	return '0'
end


-- determine the next state
function compute_next_state (action)


	if (action == 'north') then

		if (robot_state > 4) then robot_state = robot_state - 4 end

	elseif (action == 'south') then

		if (robot_state < 13) then robot_state = robot_state + 4 end

	elseif (action == 'east') then

		if (robot_state % 4 ~= 0) then robot_state = robot_state + 1 end

	elseif (action == 'west') then

		if (robot_state % 4 ~= 1) then robot_state = robot_state - 1 end

	end

	-- if we have found a terminal state, reset
	if (robot_state == 16) then
		assign_robot()
		return 1
	else
		dprint('robot_state=' .. robot_state)
		return 0
	end

end


-- debugging print
function dprint (str)

	if (debug_mode) then
		local f = io.output()
		io.output(stderr)
		print(str)
		io.output(f)
	end
end



-- main loop
line   = ''
assign_robot()

local rew = 0
local obs = '0'

repeat

	obs = compute_observation()
	dprint('obs=' .. obs .. ', rew=' .. rew)

	local enc_rew = encode_rew[rew]

	print(obs .. enc_rew)
	io.flush()

	-- grab action
	line = io.read()
	if (line == '') then break end
	action = decode_act[line];
	dprint('action=' .. action)

	rew = compute_next_state(action)

until line == ''




